{ DOCELA V POHODE}
Program Ur_Morph;
Const MaxPoints=500;
      MaxObjects=10;

Type  TObject=Array[1..MaxPoints,1..3] of Integer;
      TPObject=^TObject;
      TVScreen=Array[1..64000] of Byte;
      TPVScreen=^TVScreen;

Var  Pal:Array[0..767] of Byte;
     Napis:Array[1..253,1..2] of Integer;
     Obj,SObj:Array[1..MaxObjects] of TPObject;
     Screen,Screen1:TPVScreen;
     T,I,AnglX,AnglY,Counter,s,o,s1,o1,so1,oo1,Fseg,Fofs:Word;
     SinTab,CosTab:Array[0..359] of Integer;
     Cur:Byte;

Procedure Pln_Napis(x,y:integer;s:string);
 var a,b:byte;
     tt,ii,Num: word;
 begin
  Num:=0;
  For t:=1 to length(s) Do              { osum hodnot (radky znaku) a kazdou projedu }
   For ii:=0 to 7 do                    { tam kde sou jednicky, vykreslim bod }
    begin
     a:=mem[Fseg:Fofs+(8*ord(s[t]))+ii];
     For tt:=0 to 7 do
      begin
       asm
        Mov b,0;
        mov al,a;
        rol al,1;
        jnc @1;
        mov b,1;
      @1:
        mov a,al;
       end;
        If b=1 then
        begin
         inc(num); Napis[num,1]:=x+(t*24)+(tt*3)-12; Napis[num,2]:=y+(ii*3);
        End;
      End;
    End;

 End;

Procedure Pis(s,o:word);
Var T,x,y:Word;
Begin
For t:=1 to 253 do
begin
 x:=Napis[t,1];
 y:=Napis[t,2];
 Asm
  MOV   AX,S
  MOV   ES,AX
  MOV   DX,Y
  XCHG  DH,DL
  MOV   DI,O
  MOV   DI,DX
  SHR   DI,2
  ADD   DI,DX
  ADD   DI,X
  MOV   AL,255
  MOV   ES:[DI],Al
 End;
End;
End;
procedure GetFont; assembler;    { nastsav segment a ofset fontu }
asm mov ax,1130h;mov bh,1; int 10h; mov Fseg,es;mov Fofs,bp end;

Procedure CalcCosSin;
Var t:Integer;
Begin
For T:=0 to 359 do
  Begin
   SinTab[T]:=Round(Sin((pi/180)*T)*256);
   CosTab[T]:=Round(Cos((pi/180)*T)*256);
  End;
End;

Procedure _3dSet(X1,Y1,Z:longint;s,o:word; B:Byte);
var x,y:integer;
Begin
inc(Z,160);
X:=(X1 SHL 8) DIV Z+160;
Y:=(Y1 SHL 8) DIV Z+80;
ASM
 MOV   AX,S
 MOV   ES,AX
 MOV   DX,Y
 XCHG  DH,DL
 MOV   DI,O
 MOV   DI,DX
 SHR   DI,2
 ADD   DI,DX
 ADD   DI,X
 MOV   AL,B
 MOV   AH,AL
 MOV   ES:[DI],Ax
 MOV   ES:[DI+320],AX
END;
END;

Procedure DisplayObj(s,o:word;Num:Byte);
Begin
 For T:=1 To MaxPoints do
  _3DSet(SObj[Num]^[T,1],SObj[Num]^[T,2],SObj[Num]^[T,3],s,o,256-(SObj[Num]^[T,3]+46)*2);
End;

Procedure Zobraz(sss,oo,ss1,oo1:word;N:Byte);
Begin
 ASM
      push DS
      CLD
      MOV CX,62400;
      MOV ES,sss
      MOV DI,oo
      MOV SI,oo1
      MOV DS,ss1
      ADD DI,1280
      ADD SI,1280
      MOV bh,0
@1:
      MOV AL,ES:[DI-1]
      MOV BL,ES:[DI-320]
      ADD AX,BX
      MOV BL,ES:[DI+1]
      ADD AX,BX
      MOV BL,ES:[DI+320]
      ADD AX,BX
      SHR ax,2
      Jz @3
      DEC AX
      @3:
      MOV DS:[SI],AL
      ADD DI,1
      ADD SI,1
      DEC CX
      JNZ @1
      pop DS
      Push DS
      MOV     SI, oo
      MOV     DS, sss
      MOV     AX,0a000h
      MOV     ES,AX
      MOV     DI,0
      MOV     CX,16000
      db 66h
      REP     MOVSW
      POP DS
    End;
 DisplayObj(ss1,oo1,N);
end;


Procedure MakeCube(Num:Byte);
Var T,I,J,N:Integer;
Begin
 N:=1;
 For t:=-3 to 4 do
  For i:=-3 to 4 do
   For j:=-3 to 3 do
    Begin
     Obj[Num]^[N,1]:=(t*8-6) shl 6;  Obj[Num]^[N,2]:=(i*8-6) shl 6;
     Obj[Num]^[N,3]:=(j*8) shl 6;    Inc(N);
    End;
     For t:=N to MaxPoints do
     Begin
      Obj[Num]^[t,1]:=Obj[Num]^[N-1,1];      Obj[Num]^[t,2]:=Obj[Num]^[N-1,2];
      Obj[Num]^[t,3]:=Obj[Num]^[N-1,3];
    End;

End;

Procedure MakeTunell(Num:Byte);
 Var N:Integer;
Begin
 N:=0;
 For i:=1 to 16 do
  For t:=0 to 29 do
    Begin
     Obj[Num]^[N,1]:=(SinTab[t*12]*30 div 256) shl 6;
     Obj[Num]^[N,2]:=(CosTab[t*12]*30 div 256) shl 6;
     Obj[Num]^[N,3]:=(-30+(i*4)) shl 6;
     Inc(N);
    End;
    For t:=N to MaxPoints do
     Begin
      Obj[Num]^[t,1]:=Obj[Num]^[1,1];            Obj[Num]^[t,2]:=Obj[Num]^[1,2];
      Obj[Num]^[t,3]:=Obj[Num]^[1,3];
    End;
End;

Procedure MakeRandom(Num:Byte);
 Var N:Integer;
Begin
 N:=0;
 For i:=1 to MaxPoints do
  Begin
     Obj[Num]^[N,1]:=(Random(50)-25) shl 6;     Obj[Num]^[N,2]:=(Random(50)-25) shl 6;
     Obj[Num]^[N,3]:=(Random(50)-25) shl 6;     Inc(N);
    End;
    For t:=N to MaxPoints do
     Begin
      Obj[Num]^[t,1]:=Obj[Num]^[1,1];            Obj[Num]^[t,2]:=Obj[Num]^[1,2];
      Obj[Num]^[t,3]:=Obj[Num]^[1,3];
    End;
End;

Procedure MakeTube(Num:Byte);
 Var N:Integer;
Begin
 N:=0;
 For i:=1 to 16 do
  For t:=0 to 29 do
    Begin
     Obj[Num]^[N,1]:=(SinTab[t*12]*(sintab[i*22]*30 div 256) div 256) shl 6;
     Obj[Num]^[N,2]:=(CosTab[t*12]*(sintab[i*22]*30 div 256) div 256) shl 6;
     Obj[Num]^[N,3]:=(-30+(i*4)) shl 6;
     Inc(N);
    End;
    For t:=N to MaxPoints do
     Begin
      Obj[Num]^[t,1]:=Obj[Num]^[1,1];      Obj[Num]^[t,2]:=Obj[Num]^[1,2];
      Obj[Num]^[t,3]:=Obj[Num]^[1,3];
    End;
End;

Procedure RotateObj(Num:Byte;AngleX,AngleY,AngleZ:Word);
VAR x,y,z,xt,yt,zt:integer;
    xcos,ycos,zcos,xsin,ysin,zsin:integer;
Begin

  Xsin := Sintab[anglex];   Xcos := Sintab[(anglex+90) mod 360];
  Ysin := Sintab[angley];   Ycos := Sintab[(angley+90) mod 360];
  Zsin := Sintab[anglez];   Zcos := Sintab[(anglez+90) mod 360];

 For T:=1 to MaxPoints do
  Begin
  x:=Obj[Num]^[t,1] div 64;  y:=Obj[Num]^[t,2] div 64;
  z:=Obj[Num]^[t,3] div 64;

  Yt := (Y * Xcos - Z * Xsin) div 256 ;  Zt := (Y * Xsin + Z * Xcos) div 256;
  Y := Yt;                               Z := Zt;
  Xt := (X * Ycos - Z * Ysin) div 256;   Zt := (X * Ysin + Z * Ycos) div 256;
  X := Xt;                               Z := Zt;
  Xt := (X * Zcos - Y * Zsin) div 256;   Yt := (X * Zsin + Y * Zcos) div 256;
  X := Xt;                               Y := Yt;

  SObj[Num]^[t,1]:=X;  SObj[Num]^[t,2]:=Y;  SObj[Num]^[t,3]:=Z;
  End;
End;

Procedure LoadPal;
Var J: Integer;
 begin
  for J:=0 to 767 do
  begin
    Pal[J]:=Pal[J] shr 2;
  end;
   asm
    mov si,offset pal
    mov cx,768
    mov dx,03c8h
    xor al,al
    out dx,al
    inc dx
@1: outsb
    dec cx
    jnz @1
  end;
end;

procedure setcolor(col,r,g,b:byte);
begin
 pal[col*3]:=r;
 pal[col*3+1]:=g;
 pal[col*3+2]:=b;
end;

Procedure SetPalette;
Var T:Word;
Begin
  For t:=0 to 125 do   SetColor(t,0,0,round(t*2));
 For t:=126 to 255  do SetColor(t,round((t-126)*2),round((t-126)*2),255);
 SetColor(255,255,255,255);
 SetColor(254,254,254,255);
 SetColor(253,253,253,255);
 SetColor(252,252,252,255);
 SetColor(0,0,0,0);
 LoadPal;
End;

Procedure Morph(N1,N2,Steps:Byte);
Var T,I:Word;
Begin
  For T:=1 to MaxPoints Do
  Begin
    Obj[MaxObjects]^[T,1]:= (Obj[N1]^[T,1] - Obj[N2]^[T,1]) Div Steps;
    Obj[MaxObjects]^[T,2]:= (Obj[N1]^[T,2] - Obj[N2]^[T,2]) Div Steps;
    Obj[MaxObjects]^[T,3]:= (Obj[N1]^[T,3] - Obj[N2]^[T,3]) Div Steps;
    Obj[MaxObjects-1]^[T,1]:= Obj[N1]^[T,1] ;
    Obj[MaxObjects-1]^[T,2]:= Obj[N1]^[T,2] ;
    Obj[MaxObjects-1]^[T,3]:= Obj[N1]^[T,3] ;
  End;
  For I:=1 to Steps Do
  Begin
    For T := 1 to MaxPoints Do
    Begin
      Dec(Obj[MaxObjects-1]^[T,1],Obj[MaxObjects]^[T,1]);
      Dec(Obj[MaxObjects-1]^[T,2],Obj[MaxObjects]^[T,2]);
      Dec(Obj[MaxObjects-1]^[T,3],Obj[MaxObjects]^[T,3]);
    End;
    Inc(AnglX);    Inc(AnglY);
    If AnglX>359 Then AnglX:=0;    If AnglY>359 Then AnglY:=0;
    RotateObj(MaxObjects-1,ANGLX,ANGLY,0);
    If I mod 2=1 Then  begin Zobraz(s,o,s1,o1,MaxObjects-1);Pis(s1,o1); end
                 Else  begin Zobraz(s1,o1,s,o,MaxObjects-1);Pis(s,o); end;
 End;
 Cur:=N2;
End;

Procedure InitAll;
var t:word;
Begin
 For T:=1 to MaxObjectS do
  Begin
   New(Obj[T]);  New(SObj[T]);
  End;
 New(Screen);      New(Screen1);
 s:=seg(Screen^);  s1:=seg(Screen1^);
 o:=ofs(Screen^);  o1:=ofs(Screen1^);
 For t:=1 to 64000 do
  Begin
   Screen^[t]:=0;   Screen1^[t]:=0;
  End;

 CalcCosSin;
 MakeCube(1); Maketunell(2); MakeRandom(3); MakeTube(4);
 Asm  MOV AX,13h;INT 10h; End;   SetPalette;
End;

Begin
 GetFont;
 Pln_Napis(0,160,'R.Urban-1998');
Counter:=0;
Cur:=1;
InitAll;
repeat
 Inc(Counter);
  Case Counter of
   200: Morph(1,2,140);   400: Morph(2,4,140);
   600: Morph(4,3,140);   800: Morph(3,1,140);
   801: Counter:=0;
  End;
 If AnglX<359 Then Inc(AnglX) Else AnglX:=0;
 If AnglY<359 Then Inc(AnglY) Else AnglY:=0;
 RotateObj(Cur,ANGLX,ANGLY,0);
 If counter mod 2=1 Then  begin Zobraz(s,o,s1,o1,cur);Pis(s1,o1); end
                    Else  begin Zobraz(s1,o1,s,o,cur);Pis(s,o); end;

Until port[$60]=1;
Asm MOV AX,03h;INT 10h; End;

For T:=1 to MaxObjectS do
 Begin
  Dispose(Obj[T]);
  Dispose(SObj[T]);
 End;
Dispose(Screen); Dispose(Screen1);
End.


